git-merge.shon commit Merge branch 'ss/svnimport' (3a22917)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6USAGE='[-n] [--summary] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
   7
   8SUBDIRECTORY_OK=Yes
   9. git-sh-setup
  10require_work_tree
  11cd_to_toplevel
  12
  13test -z "$(git ls-files -u)" ||
  14        die "You are in the middle of a conflicted merge."
  15
  16LF='
  17'
  18
  19all_strategies='recur recursive octopus resolve stupid ours subtree'
  20default_twohead_strategies='recursive'
  21default_octopus_strategies='octopus'
  22no_fast_forward_strategies='subtree ours'
  23no_trivial_strategies='recursive recur subtree ours'
  24use_strategies=
  25
  26allow_fast_forward=t
  27allow_trivial_merge=t
  28
  29dropsave() {
  30        rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
  31                 "$GIT_DIR/MERGE_SAVE" || exit 1
  32}
  33
  34savestate() {
  35        # Stash away any local modifications.
  36        git diff-index -z --name-only $head |
  37        cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
  38}
  39
  40restorestate() {
  41        if test -f "$GIT_DIR/MERGE_SAVE"
  42        then
  43                git reset --hard $head >/dev/null
  44                cpio -iuv <"$GIT_DIR/MERGE_SAVE"
  45                git update-index --refresh >/dev/null
  46        fi
  47}
  48
  49finish_up_to_date () {
  50        case "$squash" in
  51        t)
  52                echo "$1 (nothing to squash)" ;;
  53        '')
  54                echo "$1" ;;
  55        esac
  56        dropsave
  57}
  58
  59squash_message () {
  60        echo Squashed commit of the following:
  61        echo
  62        git log --no-merges ^"$head" $remote
  63}
  64
  65finish () {
  66        if test '' = "$2"
  67        then
  68                rlogm="$GIT_REFLOG_ACTION"
  69        else
  70                echo "$2"
  71                rlogm="$GIT_REFLOG_ACTION: $2"
  72        fi
  73        case "$squash" in
  74        t)
  75                echo "Squash commit -- not updating HEAD"
  76                squash_message >"$GIT_DIR/SQUASH_MSG"
  77                ;;
  78        '')
  79                case "$merge_msg" in
  80                '')
  81                        echo "No merge message -- not updating HEAD"
  82                        ;;
  83                *)
  84                        git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
  85                        ;;
  86                esac
  87                ;;
  88        esac
  89        case "$1" in
  90        '')
  91                ;;
  92        ?*)
  93                if test "$show_diffstat" = t
  94                then
  95                        # We want color (if set), but no pager
  96                        GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
  97                fi
  98                ;;
  99        esac
 100
 101        # Run a post-merge hook
 102        if test -x "$GIT_DIR"/hooks/post-merge
 103        then
 104            case "$squash" in
 105            t)
 106                "$GIT_DIR"/hooks/post-merge 1
 107                ;;
 108            '')
 109                "$GIT_DIR"/hooks/post-merge 0
 110                ;;
 111            esac
 112        fi
 113}
 114
 115merge_name () {
 116        remote="$1"
 117        rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
 118        bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
 119        if test "$rh" = "$bh"
 120        then
 121                echo "$rh               branch '$remote' of ."
 122        elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
 123                git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
 124        then
 125                echo "$rh               branch '$truname' (early part) of ."
 126        elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
 127        then
 128                sed -e 's/      not-for-merge   /               /' -e 1q \
 129                        "$GIT_DIR/FETCH_HEAD"
 130        else
 131                echo "$rh               commit '$remote'"
 132        fi
 133}
 134
 135case "$#" in 0) usage ;; esac
 136
 137have_message=
 138while test $# != 0
 139do
 140        case "$1" in
 141        -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
 142                --no-summa|--no-summar|--no-summary)
 143                show_diffstat=false ;;
 144        --summary)
 145                show_diffstat=t ;;
 146        --sq|--squ|--squa|--squas|--squash)
 147                squash=t no_commit=t ;;
 148        --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
 149                no_commit=t ;;
 150        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 151                --strateg=*|--strategy=*|\
 152        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 153                case "$#,$1" in
 154                *,*=*)
 155                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 156                1,*)
 157                        usage ;;
 158                *)
 159                        strategy="$2"
 160                        shift ;;
 161                esac
 162                case " $all_strategies " in
 163                *" $strategy "*)
 164                        use_strategies="$use_strategies$strategy " ;;
 165                *)
 166                        die "available strategies are: $all_strategies" ;;
 167                esac
 168                ;;
 169        -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
 170                merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 171                have_message=t
 172                ;;
 173        -m|--m|--me|--mes|--mess|--messa|--messag|--message)
 174                shift
 175                case "$#" in
 176                1)      usage ;;
 177                esac
 178                merge_msg="$1"
 179                have_message=t
 180                ;;
 181        -*)     usage ;;
 182        *)      break ;;
 183        esac
 184        shift
 185done
 186
 187if test -z "$show_diffstat"; then
 188    test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
 189    test -z "$show_diffstat" && show_diffstat=t
 190fi
 191
 192# This could be traditional "merge <msg> HEAD <commit>..."  and the
 193# way we can tell it is to see if the second token is HEAD, but some
 194# people might have misused the interface and used a committish that
 195# is the same as HEAD there instead.  Traditional format never would
 196# have "-m" so it is an additional safety measure to check for it.
 197
 198if test -z "$have_message" &&
 199        second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
 200        head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
 201        test "$second_token" = "$head_commit"
 202then
 203        merge_msg="$1"
 204        shift
 205        head_arg="$1"
 206        shift
 207elif ! git rev-parse --verify HEAD >/dev/null 2>&1
 208then
 209        # If the merged head is a valid one there is no reason to
 210        # forbid "git merge" into a branch yet to be born.  We do
 211        # the same for "git pull".
 212        if test 1 -ne $#
 213        then
 214                echo >&2 "Can merge only exactly one commit into empty head"
 215                exit 1
 216        fi
 217
 218        rh=$(git rev-parse --verify "$1^0") ||
 219                die "$1 - not something we can merge"
 220
 221        git update-ref -m "initial pull" HEAD "$rh" "" &&
 222        git read-tree --reset -u HEAD
 223        exit
 224
 225else
 226        # We are invoked directly as the first-class UI.
 227        head_arg=HEAD
 228
 229        # All the rest are the commits being merged; prepare
 230        # the standard merge summary message to be appended to
 231        # the given message.  If remote is invalid we will die
 232        # later in the common codepath so we discard the error
 233        # in this loop.
 234        merge_name=$(for remote
 235                do
 236                        merge_name "$remote"
 237                done | git fmt-merge-msg
 238        )
 239        merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
 240fi
 241head=$(git rev-parse --verify "$head_arg"^0) || usage
 242
 243# All the rest are remote heads
 244test "$#" = 0 && usage ;# we need at least one remote head.
 245set_reflog_action "merge $*"
 246
 247remoteheads=
 248for remote
 249do
 250        remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
 251            die "$remote - not something we can merge"
 252        remoteheads="${remoteheads}$remotehead "
 253        eval GITHEAD_$remotehead='"$remote"'
 254        export GITHEAD_$remotehead
 255done
 256set x $remoteheads ; shift
 257
 258case "$use_strategies" in
 259'')
 260        case "$#" in
 261        1)
 262                var="`git config --get pull.twohead`"
 263                if test -n "$var"
 264                then
 265                        use_strategies="$var"
 266                else
 267                        use_strategies="$default_twohead_strategies"
 268                fi ;;
 269        *)
 270                var="`git config --get pull.octopus`"
 271                if test -n "$var"
 272                then
 273                        use_strategies="$var"
 274                else
 275                        use_strategies="$default_octopus_strategies"
 276                fi ;;
 277        esac
 278        ;;
 279esac
 280
 281for s in $use_strategies
 282do
 283        for ss in $no_fast_forward_strategies
 284        do
 285                case " $s " in
 286                *" $ss "*)
 287                        allow_fast_forward=f
 288                        break
 289                        ;;
 290                esac
 291        done
 292        for ss in $no_trivial_strategies
 293        do
 294                case " $s " in
 295                *" $ss "*)
 296                        allow_trivial_merge=f
 297                        break
 298                        ;;
 299                esac
 300        done
 301done
 302
 303case "$#" in
 3041)
 305        common=$(git merge-base --all $head "$@")
 306        ;;
 307*)
 308        common=$(git show-branch --merge-base $head "$@")
 309        ;;
 310esac
 311echo "$head" >"$GIT_DIR/ORIG_HEAD"
 312
 313case "$allow_fast_forward,$#,$common,$no_commit" in
 314?,*,'',*)
 315        # No common ancestors found. We need a real merge.
 316        ;;
 317?,1,"$1",*)
 318        # If head can reach all the merge then we are up to date.
 319        # but first the most common case of merging one remote.
 320        finish_up_to_date "Already up-to-date."
 321        exit 0
 322        ;;
 323t,1,"$head",*)
 324        # Again the most common case of merging one remote.
 325        echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
 326        git update-index --refresh 2>/dev/null
 327        msg="Fast forward"
 328        if test -n "$have_message"
 329        then
 330                msg="$msg (no commit created; -m option ignored)"
 331        fi
 332        new_head=$(git rev-parse --verify "$1^0") &&
 333        git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
 334        finish "$new_head" "$msg" || exit
 335        dropsave
 336        exit 0
 337        ;;
 338?,1,?*"$LF"?*,*)
 339        # We are not doing octopus and not fast forward.  Need a
 340        # real merge.
 341        ;;
 342?,1,*,)
 343        # We are not doing octopus, not fast forward, and have only
 344        # one common.
 345        git update-index --refresh 2>/dev/null
 346        case "$allow_trivial_merge" in
 347        t)
 348                # See if it is really trivial.
 349                git var GIT_COMMITTER_IDENT >/dev/null || exit
 350                echo "Trying really trivial in-index merge..."
 351                if git read-tree --trivial -m -u -v $common $head "$1" &&
 352                   result_tree=$(git write-tree)
 353                then
 354                        echo "Wonderful."
 355                        result_commit=$(
 356                                printf '%s\n' "$merge_msg" |
 357                                git commit-tree $result_tree -p HEAD -p "$1"
 358                        ) || exit
 359                        finish "$result_commit" "In-index merge"
 360                        dropsave
 361                        exit 0
 362                fi
 363                echo "Nope."
 364        esac
 365        ;;
 366*)
 367        # An octopus.  If we can reach all the remote we are up to date.
 368        up_to_date=t
 369        for remote
 370        do
 371                common_one=$(git merge-base --all $head $remote)
 372                if test "$common_one" != "$remote"
 373                then
 374                        up_to_date=f
 375                        break
 376                fi
 377        done
 378        if test "$up_to_date" = t
 379        then
 380                finish_up_to_date "Already up-to-date. Yeeah!"
 381                exit 0
 382        fi
 383        ;;
 384esac
 385
 386# We are going to make a new commit.
 387git var GIT_COMMITTER_IDENT >/dev/null || exit
 388
 389# At this point, we need a real merge.  No matter what strategy
 390# we use, it would operate on the index, possibly affecting the
 391# working tree, and when resolved cleanly, have the desired tree
 392# in the index -- this means that the index must be in sync with
 393# the $head commit.  The strategies are responsible to ensure this.
 394
 395case "$use_strategies" in
 396?*' '?*)
 397    # Stash away the local changes so that we can try more than one.
 398    savestate
 399    single_strategy=no
 400    ;;
 401*)
 402    rm -f "$GIT_DIR/MERGE_SAVE"
 403    single_strategy=yes
 404    ;;
 405esac
 406
 407result_tree= best_cnt=-1 best_strategy= wt_strategy=
 408merge_was_ok=
 409for strategy in $use_strategies
 410do
 411    test "$wt_strategy" = '' || {
 412        echo "Rewinding the tree to pristine..."
 413        restorestate
 414    }
 415    case "$single_strategy" in
 416    no)
 417        echo "Trying merge strategy $strategy..."
 418        ;;
 419    esac
 420
 421    # Remember which strategy left the state in the working tree
 422    wt_strategy=$strategy
 423
 424    git-merge-$strategy $common -- "$head_arg" "$@"
 425    exit=$?
 426    if test "$no_commit" = t && test "$exit" = 0
 427    then
 428        merge_was_ok=t
 429        exit=1 ;# pretend it left conflicts.
 430    fi
 431
 432    test "$exit" = 0 || {
 433
 434        # The backend exits with 1 when conflicts are left to be resolved,
 435        # with 2 when it does not handle the given merge at all.
 436
 437        if test "$exit" -eq 1
 438        then
 439            cnt=`{
 440                git diff-files --name-only
 441                git ls-files --unmerged
 442            } | wc -l`
 443            if test $best_cnt -le 0 -o $cnt -le $best_cnt
 444            then
 445                best_strategy=$strategy
 446                best_cnt=$cnt
 447            fi
 448        fi
 449        continue
 450    }
 451
 452    # Automerge succeeded.
 453    result_tree=$(git write-tree) && break
 454done
 455
 456# If we have a resulting tree, that means the strategy module
 457# auto resolved the merge cleanly.
 458if test '' != "$result_tree"
 459then
 460    parents=$(git show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
 461    result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
 462    finish "$result_commit" "Merge made by $wt_strategy."
 463    dropsave
 464    exit 0
 465fi
 466
 467# Pick the result from the best strategy and have the user fix it up.
 468case "$best_strategy" in
 469'')
 470        restorestate
 471        case "$use_strategies" in
 472        ?*' '?*)
 473                echo >&2 "No merge strategy handled the merge."
 474                ;;
 475        *)
 476                echo >&2 "Merge with strategy $use_strategies failed."
 477                ;;
 478        esac
 479        exit 2
 480        ;;
 481"$wt_strategy")
 482        # We already have its result in the working tree.
 483        ;;
 484*)
 485        echo "Rewinding the tree to pristine..."
 486        restorestate
 487        echo "Using the $best_strategy to prepare resolving by hand."
 488        git-merge-$best_strategy $common -- "$head_arg" "$@"
 489        ;;
 490esac
 491
 492if test "$squash" = t
 493then
 494        finish
 495else
 496        for remote
 497        do
 498                echo $remote
 499        done >"$GIT_DIR/MERGE_HEAD"
 500        printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
 501fi
 502
 503if test "$merge_was_ok" = t
 504then
 505        echo >&2 \
 506        "Automatic merge went well; stopped before committing as requested"
 507        exit 0
 508else
 509        {
 510            echo '
 511Conflicts:
 512'
 513                git ls-files --unmerged |
 514                sed -e 's/^[^   ]*      /       /' |
 515                uniq
 516        } >>"$GIT_DIR/MERGE_MSG"
 517        git rerere
 518        die "Automatic merge failed; fix conflicts and then commit the result."
 519fi